package com.tptj.demo.hg.web.resource;

import com.fr.decision.fun.impl.AbstractWebResourceProvider;
import com.fr.intelli.record.Focus;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.web.struct.Atom;
import com.fr.web.struct.Component;
import com.fr.web.struct.browser.RequestClient;
import com.fr.web.struct.category.FileType;
import com.fr.web.struct.category.ParserType;
import com.fr.web.struct.category.ScriptPath;
import com.fr.web.struct.category.StylePath;

import java.util.ArrayList;
import java.util.List;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-03-09
 **/
@EnableMetrics
public abstract class Demo extends AbstractWebResourceProvider {
    //Atom client() 接口已废弃，通过clients()兼容，以后的插件中全部都以clients实现

    @Focus(id = "com.tptj.demo.hg.web.resource.v10",text = "WEB组件资源")
    protected Atom[] demo(String ... names ){
        List<Atom> rt = new ArrayList<Atom>(names.length);
        for( String name : names ){
            rt.add(new Component() {
                @Override
                public ScriptPath script(RequestClient client) {
                    return ScriptPath.build("com/tptj/demo/hg/web/resource/"+name+".js");
                }
                @Override
                public StylePath style(RequestClient client) {
                    return StylePath.build("com/tptj/demo/hg/web/resource/demo.css");
                }
            });
        }
        return rt.toArray(new Atom[names.length]);
    }

    /**
     * 组件中包含${}表达式的解析示例
     * @return
     */
    protected Atom demoDynamic(){
        return new Component() {
            @Override
            public ScriptPath script(RequestClient client) {
                return ScriptPath.build( "com/tptj/demo/hg/web/resource/dynamic.js", ParserType.DYNAMIC );
            }
            @Override
            public StylePath style(RequestClient client) {
                return StylePath.build("com/tptj/demo/hg/web/resource/dynamic.css",ParserType.DYNAMIC);
            }
        };
    }

    /**
     * 通过class把一个java类转换成js脚本的示例
     * @return
     */
    protected Atom demoClass(){
        return new Component() {
            @Override
            public ScriptPath script(RequestClient client) {
                return ScriptPath.build( JsClassDemo.class.getName(), FileType.CLASS );
            }
        };
    }

    /**
     * 通过class生成js脚本的简单示例
     * @return
     */
    protected Atom demoSimpleClass(){
        return new Component() {
            @Override
            public ScriptPath script(RequestClient client) {
                return ScriptPath.build( JsClassSimpleDemo.class.getName(), FileType.CLASS );
            }
        };
    }
}
